<script lang="ts" setup>
import { ref, unref } from 'vue';

import { useVbenModal } from '@vben/common-ui';

import { message } from 'ant-design-vue';

import { useFormOptions, useVbenForm } from '#/adapter';
import { DictionaryApi } from '#/api';

import { useSchema } from './data.config';

defineOptions({
  name: 'DictionaryTypeEdit',
});
const emit = defineEmits(['success']);
const modelRef = ref<Record<string, any>>({});
const isUpdate = ref(true);

const [Form, { validate, setValues, getValues }] = useVbenForm(
  useFormOptions({
    schema: useSchema(),
  }),
);

const [Modal, { close, setState, getData }] = useVbenModal({
  fullscreenButton: false,
  draggable: true,
  onConfirm: async () => {
    try {
      const { valid } = await validate();
      if (valid) {
        const values = await getValues();
        setState({ confirmLoading: true });
        const postParams = unref(modelRef);
        Object.assign(postParams, values);
        await (unref(isUpdate)
          ? DictionaryApi.editTypeDetail(postParams as DictionaryApi.RecordItem)
          : DictionaryApi.addTypeDetail(
              postParams as DictionaryApi.BasicRecordItem,
            ));
        message.success('操作成功');

        close();
        emit('success');
      }
    } catch {
      message.error('操作失败');
    } finally {
      setState({ confirmLoading: false });
    }
  },
  onOpenChange: async (isOpen: boolean) => {
    if (isOpen) {
      setState({ loading: true });
      const data = getData<Record<string, any>>();
      isUpdate.value = !!data.isUpdate;
      modelRef.value = { ...data.baseData };
      setState({ title: unref(isUpdate) ? '编辑字典类型' : '新增字典类型' });

      if (unref(isUpdate)) {
        const entity = await DictionaryApi.getTypeDetail(data.baseData.id);
        modelRef.value = { ...entity };
        setValues(entity);
      }
      setState({ loading: false });
    }
  },
  title: '新增字典类型',
});
</script>
<template>
  <Modal class="w-[1000px]">
    <Form />
  </Modal>
</template>
